import { Component, EventEmitter, Output, Input, HostListener, ElementRef, NgModule } from '@angular/core';
import * as moment_ from 'moment';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';

var moment = moment_;
var DatePickerComponent = /** @class */ (function () {
    function DatePickerComponent(el) {
        this.el = el;
        this.dropdown = false;
        this.today = new Date();
        this.selecteddateIntext = 'DD/MM/YYYY';
        this.selectedDateDisplayFormat = 'DD/MM/YYYY';
        this._mode = 'dropdown';
        this.selected = new EventEmitter();
        this.monthArr = [];
        this.week1 = [];
        this.week2 = [];
        this.week3 = [];
        this.week4 = [];
        this.week5 = [];
        this.week6 = [];
        this.monthNames = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
        this.weekNames = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
        this.today.setHours(0, 0, 0, 0);
        this.generateCurrent(this.today);
    }
    Object.defineProperty(DatePickerComponent.prototype, "mode", {
        set: function (mode) {
            this._mode = mode;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePickerComponent.prototype, "format", {
        set: function (format) {
            this.selectedDateDisplayFormat = format;
            if (this.selecteddate != null) {
                this.selecteddateIntext = moment(this.selecteddate).format(this.selectedDateDisplayFormat);
            }
            else {
                this.selecteddateIntext = format;
            }
        },
        enumerable: true,
        configurable: true
    });
    DatePickerComponent.prototype.ngOnInit = function () {
    };
    DatePickerComponent.prototype.clickout = function (event) {
        if (!this.el.nativeElement.contains(event.target)) {
            this.dropdown = false;
        }
    };
    DatePickerComponent.prototype.generateCurrent = function (currentday) {
        this.currentMonth = moment(currentday).month() + 1;
        this.currentMonthInWords = this.monthNames[this.currentMonth - 1];
        this.currentYear = moment(currentday).year();
        this.start = moment(currentday).startOf('month');
        this.end = moment(currentday).endOf('month').subtract(1, 'days');
        this.generateDaysOfMonth();
    };
    DatePickerComponent.prototype.generateDaysOfMonth = function () {
        var start = this.start;
        var end = this.end;
        this.monthArr = [];
        this.monthArr.push(this.createDateObj(start));
        while (start < end) {
            start = moment(start).add(1, 'days');
            var dateobj = new DateObject();
            dateobj = this.createDateObj(start);
            this.monthArr.push(dateobj);
        }
        this.generateWeeks();
    };
    DatePickerComponent.prototype.createDateObj = function (start) {
        var dateobj = new DateObject();
        dateobj.date = start.toDate();
        dateobj.weekDay = start.day();
        dateobj.day = start.date();
        dateobj.month = start.month();
        dateobj.year = start.year();
        return dateobj;
    };
    DatePickerComponent.prototype.generateWeeks = function () {
        this.weekObject = [];
        this.weekObject.push([null, null, null, null, null, null, null]);
        this.weekObject.push([null, null, null, null, null, null, null]);
        this.weekObject.push([null, null, null, null, null, null, null]);
        this.weekObject.push([null, null, null, null, null, null, null]);
        this.weekObject.push([null, null, null, null, null, null, null]);
        this.weekObject.push([null, null, null, null, null, null, null]);
        var len = this.monthArr.length;
        var i = 0;
        for (var k = 0; k < len; k++) {
            var day = this.monthArr[k].weekDay;
            if (day === 6) {
                this.weekObject[i][day] = this.monthArr[k];
                i++;
            }
            else {
                this.weekObject[i][day] = this.monthArr[k];
            }
        }
        console.log(this.weekObject);
    };
    DatePickerComponent.prototype.changeInYear = function () {
        this.start = moment(this.start).set('year', this.currentYear);
        this.generateCurrent(this.start);
    };
    DatePickerComponent.prototype.increaseMonth = function () {
        this.start = moment(this.start).add(1, 'month');
        this.generateCurrent(this.start);
    };
    DatePickerComponent.prototype.decreaseMonth = function () {
        this.start = moment(this.start).subtract(1, 'month');
        this.generateCurrent(this.start);
    };
    DatePickerComponent.prototype.selectedDate = function (date) {
        this.selecteddate = date.date;
        this.selected.emit(this.selecteddate);
        this.selecteddateIntext = moment(date.date).format(this.selectedDateDisplayFormat);
        this.dropdown = false;
    };
    DatePickerComponent.prototype.toggle = function () {
        this.dropdown = !this.dropdown;
        console.log(this.dropdown);
    };
    return DatePickerComponent;
}());
DatePickerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-date-picker',
                template: "\n<div class=\"dropdown\" *ngIf=\"_mode === 'dropdown'\">\n  <button (click)=\"toggle();\" class=\"dropbtn\" > {{selecteddateIntext}}</button>\n    <div id=\"myDropdown\" class=\"dropdown-content\" [ngClass]=\"{'show':dropdown}\">\n      <div *ngIf=\"true; then datepicker\" >\n        \n     </div>\n    </div>\n</div>\n\n<div  *ngIf=\"_mode === 'inline'\" >\n        <div *ngIf=\"true; then datepicker\" > </div>\n</div>\n\n\n\n  <ng-template #datepicker>\n    <div style=\"width:325px;height:316px;\">\n      <div class=\"month\">      \n        <ul>\n          <li class=\"prev\" (click)=\"decreaseMonth();\">&#10094;</li>\n          <li class=\"next\" (click)=\"increaseMonth();\">&#10095;</li>\n          <li>\n            {{currentMonthInWords}}\n            <span style=\"font-size:18px\"><input type=\"number\" min=0 max=3000 [(ngModel)]=\"currentYear\" (change)=\"changeInYear()\"></span>\n          </li>\n        </ul>\n      </div>\n      \n      <ul class=\"weekdays\">\n        <li>Su</li>\n        <li>Mo</li>\n        <li>Tu</li>\n        <li>We</li>\n        <li>Th</li>\n        <li>Fr</li>\n        <li>Sa</li>\n      </ul>\n      \n      <ul class=\"days\">  \n        \n        <li *ngFor=\"let d of weekObject[0]\" (click)=\"selectedDate(d);\"><span [ngClass]=\" d?.date - selecteddate === 0?'active':''\" >{{d?.day}}</span></li>\n        <li *ngFor=\"let d of weekObject[1]\" (click)=\"selectedDate(d);\"><span [ngClass]=\" d?.date - selecteddate === 0?'active':''\" >{{d?.day}}</span></li>\n        <li *ngFor=\"let d of weekObject[2]\" (click)=\"selectedDate(d);\"><span [ngClass]=\" d?.date - selecteddate === 0?'active':''\" >{{d?.day}}</span></li>\n        <li *ngFor=\"let d of weekObject[3]\" (click)=\"selectedDate(d);\"><span [ngClass]=\" d?.date - selecteddate === 0?'active':''\" >{{d?.day}}</span></li>\n        <li *ngFor=\"let d of weekObject[4]\" (click)=\"selectedDate(d);\"><span [ngClass]=\" d?.date - selecteddate === 0?'active':''\" >{{d?.day}}</span></li>\n        <li *ngFor=\"let d of weekObject[5]\" (click)=\"selectedDate(d);\"><span [ngClass]=\" d?.date - selecteddate === 0?'active':''\" >{{d?.day}}</span></li>\n        <li *ngFor=\"let d of weekObject[6]\" (click)=\"selectedDate(d);\"><span [ngClass]=\" d?.date - selecteddate === 0?'active':''\" >{{d?.day}}</span></li>\n      </ul>\n      </div>\n </ng-template>",
                styles: ["*{-webkit-box-sizing:border-box;box-sizing:border-box}ul{list-style-type:none;font-family:Arial,Helvetica,sans-serif}.month{padding:25px;width:100%;background:#85b7e2;text-align:center}.month ul{margin:0;padding:0}.month ul li{color:#fff;font-size:20px;letter-spacing:3px}.month .prev{float:left;cursor:pointer}.month .next{float:right;cursor:pointer}.weekdays{margin:0;padding:10px 0;background-color:#c2dbf0}.weekdays li{display:inline-block;width:12.6%;color:#102940;text-align:center}.days{padding:10px 0;background:#edf4fb;margin:0}.days li{list-style-type:none;display:inline-block;width:13.6%;text-align:center;margin-bottom:5px;font-size:12px;color:#102940;cursor:pointer}.days li .active{padding:5px;background:#85b7e2;color:#fff!important}@media screen and (max-width:720px){.days li,.weekdays li{width:13.1%}}@media screen and (max-width:420px){.days li,.weekdays li{width:12.5%}.days li .active{padding:2px}}@media screen and (max-width:290px){.days li,.weekdays li{width:12.2%}}input[type=number]{padding:0;margin:8px 0;background:0 0;border:none;color:#fff;font-size:18px;text-align:center}.dropbtn{background-color:#3498db;color:#fff;padding:16px;font-size:16px;border:none;cursor:pointer}.dropbtn:focus,.dropbtn:hover{background-color:#2980b9}.dropdown{position:relative;display:inline-block}.dropdown-content{display:none;position:absolute;background-color:#f1f1f1;min-width:160px;overflow:auto;-webkit-box-shadow:0 8px 16px 0 rgba(0,0,0,.2);box-shadow:0 8px 16px 0 rgba(0,0,0,.2);z-index:1}.dropdown-content a{color:#000;padding:12px 16px;text-decoration:none;display:block}.dropdown a:hover{background-color:#ddd}.show{display:block!important}"]
            },] },
];
DatePickerComponent.ctorParameters = function () { return [
    { type: ElementRef, },
]; };
DatePickerComponent.propDecorators = {
    "mode": [{ type: Input, args: ['mode',] },],
    "format": [{ type: Input, args: ['format',] },],
    "selected": [{ type: Output },],
    "clickout": [{ type: HostListener, args: ['document:click', ['$event'],] },],
};
var DateObject = /** @class */ (function () {
    function DateObject() {
    }
    return DateObject;
}());
var NgxDatePickerModule = /** @class */ (function () {
    function NgxDatePickerModule() {
    }
    return NgxDatePickerModule;
}());
NgxDatePickerModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule, FormsModule
                ],
                declarations: [DatePickerComponent],
                exports: [
                    DatePickerComponent
                ]
            },] },
];

export { NgxDatePickerModule, DatePickerComponent as ɵa };
//# sourceMappingURL=ngx-date-picker-component.js.map
